'*************************************************************
'* QSpinEdit - component  v 0.99
'* 2005 Nastase Eodor
'* Generated by RqWork v 7.0.0 Beta
'* eodor@3x.ro  http://rqwork.3x.ro
'*************************************************************
Type QSpinEdit Extends QPanel
     Private:
     Chars(10)        As String
     Up             As QCoolBtn
     Down           As QCoolBtn
     Edit           As QEdit
     Bitmap         As QBitmap
     TTimer         As QTimer
     UpFlag         As Integer
     DownFlag       As Integer
     Space          As Integer
     UpGlyph(142)   As Integer
     DownGlyph(142) As Integer
     
     Public:
     MinValue  As Double
     MaxValue  As Double
     Increment As Double
     Value     As Double
     Flat      As Integer Property Set SetFlat

     With This
     
     Sub LoadGlyphs 'store bitmaps as integer array
     Dim M As QMemoryStream
     Dim s As String,i As Integer
     InitArray(This.UpGlyph,66,77,142,0,0,0,0,0,0,0,118,0,0,0,40,0,0,_  'up.bmp
                           0,8,0,0,0,6,0,0,0,1,0,4,0,0,0,0,0,_
                           24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,_
                           0,0,0,0,0,0,0,0,0,128,0,0,128,0,0,0,128,_
                           128,0,128,0,0,0,128,0,128,0,128,128,0,0,128,128,128,_
                           0,192,192,192,0,0,0,255,0,0,255,0,0,0,255,255,0,_
                           255,0,0,0,255,0,255,0,255,255,0,0,255,255,255,0,221,_
                           221,221,221,221,221,221,221,0,0,0,0,208,0,0,13,221,0,_
                           0,221,221,208,13,221)
     InitArray(This.DownGlyph,66,77,142,0,0,0,0,0,0,0,118,0,0,0,40,0,0,_  'down.bmp
                           0,8,0,0,0,6,0,0,0,1,0,4,0,0,0,0,0,_
                           24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,_
                           0,0,0,0,0,0,0,0,0,128,0,0,128,0,0,0,128,_
                           128,0,128,0,0,0,128,0,128,0,128,128,0,0,128,128,128,_
                           0,192,192,192,0,0,0,255,0,0,255,0,0,0,255,255,0,_
                           255,0,0,0,255,0,255,0,255,255,0,0,255,255,255,0,221,_
                           221,221,221,221,221,221,221,221,208,13,221,221,0,0,221,208,0,_
                           0,13,0,0,0,0)
     s = ""
     For i = 0 to UBound(This.UpGlyph) -1
         s = s + Chr$(This.UpGlyph(i))
     Next i
     M.Position = 0
     M.WriteBinStr(s,Len(s))
     M.Position = 0
     .Bitmap.LoadFromStream(M)
     .Up.BMP = .Bitmap.BMP
     s = ""
     For i = 0 to UBound(This.DownGlyph) -1
         s = s + Chr$(This.DownGlyph(i))
     Next i
     M.Position = 0
     M.WriteBinStr(s,Len(s))
     M.Position = 0
     .Bitmap.LoadFromStream(M)
     .Down.BMP = .Bitmap.BMP
     M.Close
     End Sub
     
     Event Up.OnClick
     If .Value > .MaxValue then
        .Value = .MaxValue
     End If
     Inc(.Value,.Increment)
     .Edit.Text = Str$(.Value)
     End Event
     
     Event Down.OnClick
     If .Value < .MinValue then
        .Value = .MinValue
     End If
     Dec(.Value,.Increment)
     .Edit.Text = Str$(.Value)
     End Event
     
     Event TTimer.OnTimer
     If .UpFlag then
        If .Value > .MaxValue then
           .Value = .MaxValue
        End If
        Inc(.Value,.Increment)
        .Edit.Text = Str$(.Value)
     End If
     If .DownFlag then
        If .Value < .MinValue then
           .Value = .MinValue
        End If
        Dec(.Value,.Increment)
        .Edit.Text = Str$(.Value)
     End If
     End Event
     
     Event Edit.OnChange
     .Value = val(.Edit.Text)
     If .Value > .MaxValue then
        .Value = .MaxValue
     End If
     If .Value < .MinValue then
        .Value = .MinValue
     End If
     .Edit.Text = Str$(.Value)
     End Event
     
     Event Up.OnMouseDown
     .TTimer.Enabled = 1
     .UpFlag   = 1
     .DownFlag = 0
     End Event
     
     Event Up.OnMouseUp
     .TTimer.Enabled = 0
     .UpFlag   = 0
     .DownFlag = 0
     End Event
     
     Event Down.OnMouseDown
     .TTimer.Enabled = 1
     .DownFlag = 1
     .UpFlag   = 0
     End Event

     Event Down.OnMouseUp
     .TTimer.Enabled = 0
     .DownFlag = 0
     .UpFlag   = 0
     End Event

     Event Edit.OnKeyPress(Key As Byte)
     Defint i
           Function IsCharValid(Key As Byte) As Integer
           Result = 0
           For i = 0 to UBound(This.Chars) -1
              If Str$(Key) = This.Chars(i) then
                 Result = 1
                 Exit For
              End If
           Next i
           End Function
     If .IsCharValid(Key) = 0 then
        Key = 0
     End If
     End Event
     
     Sub AddResources(UpRes As Integer,DownRes As Integer)
     Dim M As QMemoryStream
     M.Position = 0
     M.ExtractRes(Resource(UpRes))
     M.Position = 0
     .Bitmap.LoadFromStream(M)
     .Up.BMP = .Bitmap.BMP
     M.Position = 0
     M.ExtractRes(Resource(DownRes))
     M.Position = 0
     .Bitmap.LoadFromStream(M)
     .Down.BMP = .Bitmap.BMP
     M.Close
     End Sub
     
     Sub Update
     .Up.Height   = .Height\2
     .Space       = .Height - 2*.Up.Height
     .Down.Height = .Up.Height
     .Up.Width    = 18
     .Down.Width  = .Up.Width
     .Edit.Width  = .Width - .Up.Width
     .Edit.Align  = 3
     .Edit.Text   = Str$(.Value)
     .Edit.Parent = This
     .Up.Left     = .Edit.Width
     .Down.Left   = .Up.Left
     .Up.Top      = 0
     .Down.Top    = .Up.Height + .Space
     .Up.Parent   = This
     .Down.Parent = This
     InitArray(This.Chars,"0","1","2","3","4","5","6","7","8","9",".")
     End Sub
     
     Property Set SetFlat(Value As Integer)
     .Flat      = Value
     .Up.Flat   = .Flat
     .Down.Flat = .Flat
     End Property
     
     End With
     
     Constructor
     TTimer.Interval = 220
     TTimer.Enabled  = 0
     BevelOuter      = 0
     Height          = 21
     Width           = 121
     Increment       = 1
     LoadGlyphs
     Update
     End Constructor
End Type
   
